using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
namespace Skyview_Utility
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void TxtToLog_Click(object sender, EventArgs e)
        {
            Byte mychar;
            UInt32 i, FilePointer, FileLength = 0;
            String OpenFileName, TempString;
            //  Byte[] LineData = new Byte[0x20];
            //  UInt16[] PiDList = new UInt16[30];
            float Time = 0,T1,T2,T3,T4,StartTime=0;
            float Pitch, Roll, Yaw, IAS, PAlt, TurnRate, LatG, VertG, AoA, VSpeed, OAT, TAS, Baro, DA, WS, WD, OP, OT, RPML, RPMR, MAP, FuelFlow, FP, FuelRem, V, Amps, Hobbs, Tach, TC1, TC2, TC3, TC4, TC5, TC6, TC7, TC8, TC9, TC10, TC11, TC12, ElTrim, AcroF;
            double TimeInc = (0.00009 * 1);
            try
            {


                TxtToLog.Text = "working";



                OpenFileDialog ofn = new OpenFileDialog();
                ofn.Filter = "Log Files (*.txt)|*.txt|All Files (*.*)|*.*";
                ofn.Title = "Type File";
                if (ofn.ShowDialog() == DialogResult.Cancel) return;
                FileInfo FI = new FileInfo(@ofn.FileName);
                FileLength = (UInt32)(FI.Length);
                Byte[] FileData = new Byte[FileLength];
                OpenFileName = ofn.FileName;
                FileStream inStream = File.OpenRead(OpenFileName);
                BinaryReader br = new BinaryReader(inStream);
                for (i = 0; i < FileLength; i++)
                {
                    FileData[i] = br.ReadByte();
                }
                br.Close();
                inStream.Close();



                FilePointer = 1900;
                while (FilePointer <= FileLength)
                {
                    if (FileData[FilePointer] == '!') break;
                    FilePointer++;
                }
                // test charictors to make sure there are at least one AHARS and one EMS data line

                if ((FileData[FilePointer + 1] != '1') || (FileData[FilePointer + 75] != '3'))
                {
                    MessageBox.Show("Need at least one AHARS and EMS record.  Exiting...", "Input Error",
                    MessageBoxButtons.OKCancel, MessageBoxIcon.Asterisk);
                    return;
                }

                TxtToLog.Text = "working";

                BaudRate.Text = "2400";


                TempString = "Time,T1,T2,T3,T4,Pitch,Roll,Yaw,IAS,PAlt,TurnRate,LatG,VertG,AoA,VSpeed,OAT,TAS,Baro,DA,WS,WD,OP,OT,RPML,RPMR,MAP,FuelFlow,FP,FuelRem,V,Amps,Hobbs,Tach,CHT6,EGT6,CHT5,EGT5,CHT4,EGT4,CHT2,EGT2,CHT3,EGT3,CHT1,EGT1,ElTrim,AcroF";

                //Time Incriment determined from log at 2400 baud as follows
                // 12:20:25 - 11:41:19 = 39:06 or 39.1 minutes for 1708 records or .02289 minutes/record (which is one sample every 1.37 seconds)
                // each record will be incrimented by .02289 minutes with time displayed in minutes

                //

                OpenFileName = OpenFileName + ".LOG";
                TextWriter tw = new StreamWriter(OpenFileName);

                tw.WriteLine(TempString);

                // set scales
                //low values
                Time = -2;
                Pitch = 0; Roll = 0; Yaw = 0; IAS = 0; PAlt = 0; TurnRate = 0; LatG = 0; VertG = 0; AoA = 0; VSpeed = 0; OAT = 0; TAS = 0; Baro = 0; DA = 0; WS = 0;
                WD = 0; OP = 0; OT = 0; RPML = 0; RPMR = 0; MAP = 0; FuelFlow = 0; FP = 0; FuelRem = 0; V = 0; Amps = 0; Hobbs = 0; Tach = 0;
                TC1 = 0; TC2 = 0; TC3 = 0; TC4 = 0; TC5 = 0; TC6 = 0; TC7 = 0; TC8 = 0; TC9 = 0; TC10 = 0; TC11 = 0; TC12 = 0; ElTrim = 0; AcroF = 0;
                T1 = 0; T2 = 0; T3 = 0; T4 = 0;
                TempString = Time.ToString("N0")
                + ", " + T1.ToString("N1")
                + ", " + T2.ToString("N1")
                + ", " + T3.ToString("N1")
                + ", " + T4.ToString("N1")
                +", " + Pitch.ToString("N1")
                + ", " + Roll.ToString("N1")
                + ", " + Yaw.ToString("")
                + ", " + IAS.ToString("N1")
                + ", " + PAlt.ToString("")
                + ", " + TurnRate.ToString("N1")
                + ", " + LatG.ToString("N1")
                + ", " + VertG.ToString("N1")
                + ", " + AoA.ToString("")
                + ", " + VSpeed.ToString("")
                + ", " + OAT.ToString("")
                + ", " + TAS.ToString("N1")
                + ", " + Baro.ToString("")
                + ", " + DA.ToString("")
                + ", " + WS.ToString("")
                + ", " + WD.ToString("")
                + ", " + OP.ToString("")
                + ", " + OT.ToString("")
                + ", " + RPML.ToString("")
                + ", " + RPMR.ToString("")
                + ", " + MAP.ToString("N1")
                + ", " + FuelFlow.ToString("N1")
                + ", " + FP.ToString("")
                + ", " + FuelRem.ToString("N1")
                + ", " + V.ToString("N1")
                + ", " + Amps.ToString("N1")
                + ", " + Hobbs.ToString("")
                + ", " + Tach.ToString("")
                + ", " + TC1.ToString("")
                + ", " + TC2.ToString("")
                + ", " + TC3.ToString("")
                + ", " + TC4.ToString("")
                + ", " + TC5.ToString("")
                + ", " + TC6.ToString("")
                + ", " + TC7.ToString("")
                + ", " + TC8.ToString("")
                + ", " + TC9.ToString("")
                + ", " + TC10.ToString("")
                + ", " + TC11.ToString("")
                + ", " + TC12.ToString("")
                + ", " + ElTrim.ToString("N1")
                + ", " + AcroF.ToString("N1");


                tw.WriteLine(TempString);
                Time = -1;

                // high values
                Pitch = 0; Roll = 0; Yaw = 0; IAS = 0; PAlt = 0; TurnRate = 0; LatG = 0; VertG = 0; AoA = 0; VSpeed = 0; OAT = 0; TAS = 0; Baro = 0; DA = 0; WS = 0;
                WD = 0; OP = 110; OT = 220; RPML = 2900; RPMR = 2900; MAP = 32; FuelFlow = 30; FP = 0; FuelRem = 0; V = 0; Amps = 0; Hobbs = 0; Tach = 0;
                TC1 = 450; TC2 = 1500; TC3 = 450; TC4 = 1500; TC5 = 450; TC6 = 1500; TC7 = 450; TC8 = 1500; TC9 = 450; TC10 = 1500; TC11 = 450; TC12 = 1500; ElTrim = 0; AcroF = 0;
                TempString = Time.ToString("N0")
                + ", " + T1.ToString("N1")
                + ", " + T2.ToString("N1")
                + ", " + T3.ToString("N1")
                + ", " + T4.ToString("N1")
                +", " + Pitch.ToString("N1")
                + ", " + Roll.ToString("N1")
                + ", " + Yaw.ToString("")
                + ", " + IAS.ToString("N1")
                + ", " + PAlt.ToString("")
                + ", " + TurnRate.ToString("N1")
                + ", " + LatG.ToString("N1")
                + ", " + VertG.ToString("N1")
                + ", " + AoA.ToString("")
                + ", " + VSpeed.ToString("")
                + ", " + OAT.ToString("")
                + ", " + TAS.ToString("N1")
                + ", " + Baro.ToString("")
                + ", " + DA.ToString("")
                + ", " + WS.ToString("")
                + ", " + WD.ToString("")
                + ", " + OP.ToString("")
                + ", " + OT.ToString("")
                + ", " + RPML.ToString("")
                + ", " + RPMR.ToString("")
                + ", " + MAP.ToString("N1")
                + ", " + FuelFlow.ToString("N1")
                + ", " + FP.ToString("")
                + ", " + FuelRem.ToString("N1")
                + ", " + V.ToString("N1")
                + ", " + Amps.ToString("N1")
                + ", " + Hobbs.ToString("")
                + ", " + Tach.ToString("")
                + ", " + TC1.ToString("")
                + ", " + TC2.ToString("")
                + ", " + TC3.ToString("")
                + ", " + TC4.ToString("")
                + ", " + TC5.ToString("")
                + ", " + TC6.ToString("")
                + ", " + TC7.ToString("")
                + ", " + TC8.ToString("")
                + ", " + TC9.ToString("")
                + ", " + TC10.ToString("")
                + ", " + TC11.ToString("")
                + ", " + TC12.ToString("")
                + ", " + ElTrim.ToString("N1")
                + ", " + AcroF.ToString("N1");


                tw.WriteLine(TempString);
               // Time = (float)(Time + TimeInc);


                // This sets start time in seconds
                T1 = (float)(((FileData[FilePointer + 3] - 0x30) * 10) + ((FileData[FilePointer + 4] - 0x30) * 1));   //hours
                T2 = (float)(((FileData[FilePointer + 5] - 0x30) * 10) + ((FileData[FilePointer + 6] - 0x30) * 1));   //minutes
                T3 = (float)(((FileData[FilePointer + 7] - 0x30) * 10) + ((FileData[FilePointer + 8] - 0x30) * 1));   //seconds
                T4 = (float)(((FileData[FilePointer + 9] - 0x30) * 10) + ((FileData[FilePointer + 10] - 0x30) * 1));  //16ths
                T4 = (float)(T4 / 16);
                StartTime = (float)(T3 + (T2*60) + (T1*3600) );
                StartTime -= 4;  //to get it past range setting



                while (FilePointer <= FileLength)
                {
                    T1 = (float)(((FileData[FilePointer + 3] - 0x30) * 10) + ((FileData[FilePointer + 4] - 0x30) * 1));
                    T2 = (float)(((FileData[FilePointer + 5] - 0x30) * 10) + ((FileData[FilePointer + 6] - 0x30) * 1));
                    T3 = (float)(((FileData[FilePointer + 7] - 0x30) * 10) + ((FileData[FilePointer + 8] - 0x30) * 1));
                    T4 = (float)(((FileData[FilePointer + 9] - 0x30) * 10) + ((FileData[FilePointer + 10] - 0x30) * 1));
                    T4 = (float)(T4 / 16);
                    Time = (float)(T3 + (T2 * 60) + (T1*3600));
                    Time -= StartTime;

                    Pitch = (float)(((FileData[FilePointer + 12] - 0x30) * 100) + ((FileData[FilePointer + 13] - 0x30) * 10) + ((FileData[FilePointer + 14] - 0x30) * 1));
                    Pitch = Pitch / 10;
                    if (FileData[FilePointer + 11] == '-') Pitch = -Pitch;
                    Roll = (float)(((FileData[FilePointer + 16] - 0x30) * 1000) + ((FileData[FilePointer + 17] - 0x30) * 100) + ((FileData[FilePointer + 18] - 0x30) * 10) + ((FileData[FilePointer + 19] - 0x30) * 1));
                    Roll = Roll / 10;
                    if (FileData[FilePointer + 15] == '-') Roll = -Roll;
                    Yaw = (float)(((FileData[FilePointer + 20] - 0x30) * 100) + ((FileData[FilePointer + 21] - 0x30) * 10) + ((FileData[FilePointer + 22] - 0x30) * 1));
                    //Yaw = Yaw / 10;
                    IAS = (float)(((FileData[FilePointer + 23] - 0x30) * 1000) + ((FileData[FilePointer + 24] - 0x30) * 100)
                        + ((FileData[FilePointer + 25] - 0x30) * 10) + ((FileData[FilePointer + 26] - 0x30) * 1));
                    IAS = IAS / 10;
                    PAlt = (float)(((FileData[FilePointer + 28] - 0x30) * 10000) + ((FileData[FilePointer + 29] - 0x30) * 1000)
                        + ((FileData[FilePointer + 30] - 0x30) * 100) + ((FileData[FilePointer + 31] - 0x30) * 10) + ((FileData[FilePointer + 32] - 0x30) * 1));
                    if (FileData[FilePointer + 27] == '-') PAlt = -PAlt;
                    TurnRate = (float)(((FileData[FilePointer + 34] - 0x30) * 100) + ((FileData[FilePointer + 35] - 0x30) * 10) + ((FileData[FilePointer + 36] - 0x30) * 1));
                    TurnRate = TurnRate / 10;
                    if (FileData[FilePointer + 33] == '-') TurnRate = -TurnRate;
                    LatG = (float)(((FileData[FilePointer + 38] - 0x30) * 10) + (FileData[FilePointer + 39] - 0x30));
                    LatG = LatG / 10;
                    if (FileData[FilePointer + 37] == '-') LatG = -LatG;
                    VertG = (float)(((FileData[FilePointer + 41] - 0x30) * 10) + (FileData[FilePointer + 42] - 0x30));
                    VertG = VertG / 10;
                    if (FileData[FilePointer + 40] == '-') VertG = -VertG;
                    AoA = (float)(((FileData[FilePointer + 43] - 0x30) * 10) + (FileData[FilePointer + 44] - 0x30));
                    VSpeed = (float)(((FileData[FilePointer + 46] - 0x30) * 100) + ((FileData[FilePointer + 47] - 0x30) * 10) + ((FileData[FilePointer + 48] - 0x30) * 1));
                    VSpeed *= 10;
                    if (FileData[FilePointer + 45] == '-') VSpeed = -VSpeed;
                    OAT = (float)(((FileData[FilePointer + 50] - 0x30) * 10) + (FileData[FilePointer + 51] - 0x30));
                    OAT = (float)((OAT * 1.8) + 32);  //C to F
                    if (FileData[FilePointer + 49] == '-') OAT = -OAT;
                    TAS = (float)(((FileData[FilePointer + 52] - 0x30) * 1000) + ((FileData[FilePointer + 53] - 0x30) * 100)
                        + ((FileData[FilePointer + 54] - 0x30) * 10) + ((FileData[FilePointer + 55] - 0x30) * 1));
                    TAS = TAS / 10;
                    Baro = (float)(((FileData[FilePointer + 56] - 0x30) * 100) + ((FileData[FilePointer + 57] - 0x30) * 10) + ((FileData[FilePointer + 58] - 0x30) * 1));
                    Baro = Baro / 10;
                    DA = (float)(((FileData[FilePointer + 60] - 0x30) * 10000) + ((FileData[FilePointer + 61] - 0x30) * 1000)
                        + ((FileData[FilePointer + 62] - 0x30) * 100) + ((FileData[FilePointer + 63] - 0x30) * 10) + ((FileData[FilePointer + 64] - 0x30) * 1));
                    if (FileData[FilePointer + 59] == '-') DA = -DA;



                    if (FileData[FilePointer + 65] == 'X') { WD = 0; }
                    else
                    {
                        WD = (float)(((FileData[FilePointer + 65] - 0x30) * 100) + ((FileData[FilePointer + 66] - 0x30) * 10) + ((FileData[FilePointer + 67] - 0x30) * 1));
                    }


                    if (FileData[FilePointer + 68] == 'X') { WS = 0; }
                    else
                    {
                        WS = (float)(((FileData[FilePointer + 68] - 0x30) * 10) + (FileData[FilePointer + 69] - 0x30));
                    }



                    FilePointer += 74; //point at start of next line
                    OP = (float)(((FileData[FilePointer + 11] - 0x30) * 100) + ((FileData[FilePointer + 12] - 0x30) * 10) + ((FileData[FilePointer + 13] - 0x30) * 1));
                    OT = (float)(((FileData[FilePointer + 15] - 0x30) * 100) + ((FileData[FilePointer + 16] - 0x30) * 10) + ((FileData[FilePointer + 17] - 0x30) * 1));
                    OT = (float)((OT * 1.8) + 32);  //C to F
                    if (FileData[FilePointer + 14] == '-') OT = -OT;
                    RPML = (float)(((FileData[FilePointer + 18] - 0x30) * 1000) + ((FileData[FilePointer + 19] - 0x30) * 100)
                        + ((FileData[FilePointer + 20] - 0x30) * 10) + ((FileData[FilePointer + 21] - 0x30) * 1));
                    RPMR = (float)(((FileData[FilePointer + 22] - 0x30) * 1000) + ((FileData[FilePointer + 23] - 0x30) * 100)
                        + ((FileData[FilePointer + 24] - 0x30) * 10) + ((FileData[FilePointer + 25] - 0x30) * 1));
                    MAP = (float)(((FileData[FilePointer + 26] - 0x30) * 100) + ((FileData[FilePointer + 27] - 0x30) * 10) + ((FileData[FilePointer + 28] - 0x30) * 1));
                    MAP = MAP / 10;
                    if (MAP > 34) MAP = 34;
                    FuelFlow = (float)(((FileData[FilePointer + 29] - 0x30) * 100) + ((FileData[FilePointer + 30] - 0x30) * 10) + ((FileData[FilePointer + 31] - 0x30) * 1));
                    FuelFlow = FuelFlow / 10;
                    //skip 3 for second fuel flow not used
                    FP = (float)(((FileData[FilePointer + 35] - 0x30) * 100) + ((FileData[FilePointer + 36] - 0x30) * 10) + ((FileData[FilePointer + 37] - 0x30) * 1));
                    FP = FP / 10;
                    //skip 6 for quantity L & R not used

                    FuelRem = (float)(((FileData[FilePointer + 44] - 0x30) * 100) + ((FileData[FilePointer + 45] - 0x30) * 10) + ((FileData[FilePointer + 46] - 0x30) * 1));
                    FuelRem = FuelRem / 10;
                    V = (float)(((FileData[FilePointer + 47] - 0x30) * 100) + ((FileData[FilePointer + 48] - 0x30) * 10) + ((FileData[FilePointer + 49] - 0x30) * 1));
                    V = V / 10; //skip 3 V2 not used
                    Amps = (float)(((FileData[FilePointer + 54] - 0x30) * 100) + ((FileData[FilePointer + 55] - 0x30) * 10) + ((FileData[FilePointer + 56] - 0x30) * 1));
                    Amps = Amps / 10;
                    if (FileData[FilePointer + 53] == '-') Amps = -Amps;
                    Hobbs = (float)(((FileData[FilePointer + 57] - 0x30) * 10000) + ((FileData[FilePointer + 58] - 0x30) * 1000)
                        + ((FileData[FilePointer + 59] - 0x30) * 100) + ((FileData[FilePointer + 60] - 0x30) * 10) + ((FileData[FilePointer + 61] - 0x30) * 1));
                    Hobbs = Hobbs / 10;
                    Tach = (float)(((FileData[FilePointer + 62] - 0x30) * 10000) + ((FileData[FilePointer + 63] - 0x30) * 1000)
                        + ((FileData[FilePointer + 64] - 0x30) * 100) + ((FileData[FilePointer + 65] - 0x30) * 10) + ((FileData[FilePointer + 66] - 0x30) * 1));
                    Tach = Tach / 10;
                    //TCs will use incrimented file pointer as they simply repeat in form
                    FilePointer = FilePointer + 66;
                    TC1 = (float)(((FileData[FilePointer + 2] - 0x30) * 100) + ((FileData[FilePointer + 3] - 0x30) * 10) + ((FileData[FilePointer + 4] - 0x30) * 1));
                    TC1 = (float)((TC1 * 1.8) + 32);  //C to F
                    if (FileData[FilePointer + 1] == '-') TC1 = -TC1;
                    FilePointer += 4;

                    TC2 = (float)(((FileData[FilePointer + 2] - 0x30) * 100) + ((FileData[FilePointer + 3] - 0x30) * 10) + ((FileData[FilePointer + 4] - 0x30) * 1));
                    TC2 = (float)((TC2 * 1.8) + 32);  //C to F
                    if (FileData[FilePointer + 1] == '-') TC2 = -TC2;
                    FilePointer += 4;

                    TC3 = (float)(((FileData[FilePointer + 2] - 0x30) * 100) + ((FileData[FilePointer + 3] - 0x30) * 10) + ((FileData[FilePointer + 4] - 0x30) * 1));
                    TC3 = (float)((TC3 * 1.8) + 32);  //C to F
                    if (FileData[FilePointer + 1] == '-') TC3 = -TC3;
                    FilePointer += 4;

                    TC4 = (float)(((FileData[FilePointer + 2] - 0x30) * 100) + ((FileData[FilePointer + 3] - 0x30) * 10) + ((FileData[FilePointer + 4] - 0x30) * 1));
                    TC4 = (float)((TC4 * 1.8) + 32);  //C to F
                    if (FileData[FilePointer + 1] == '-') TC4 = -TC4;
                    FilePointer += 4;

                    TC5 = (float)(((FileData[FilePointer + 2] - 0x30) * 100) + ((FileData[FilePointer + 3] - 0x30) * 10) + ((FileData[FilePointer + 4] - 0x30) * 1));
                    TC5 = (float)((TC5 * 1.8) + 32);  //C to F
                    if (FileData[FilePointer + 1] == '-') TC5 = -TC5;
                    FilePointer += 4;

                    TC6 = (float)(((FileData[FilePointer + 2] - 0x30) * 100) + ((FileData[FilePointer + 3] - 0x30) * 10) + ((FileData[FilePointer + 4] - 0x30) * 1));
                    TC6 = (float)((TC6 * 1.8) + 32);  //C to F
                    if (FileData[FilePointer + 1] == '-') TC6 = -TC6;
                    FilePointer += 4;

                    TC7 = (float)(((FileData[FilePointer + 2] - 0x30) * 100) + ((FileData[FilePointer + 3] - 0x30) * 10) + ((FileData[FilePointer + 4] - 0x30) * 1));
                    TC7 = (float)((TC7 * 1.8) + 32);  //C to F
                    if (FileData[FilePointer + 1] == '-') TC7 = -TC7;
                    FilePointer += 4;

                    TC8 = (float)(((FileData[FilePointer + 2] - 0x30) * 100) + ((FileData[FilePointer + 3] - 0x30) * 10) + ((FileData[FilePointer + 4] - 0x30) * 1));
                    TC8 = (float)((TC8 * 1.8) + 32);  //C to F
                    if (FileData[FilePointer + 1] == '-') TC8 = -TC8;
                    FilePointer += 4;

                    TC9 = (float)(((FileData[FilePointer + 2] - 0x30) * 100) + ((FileData[FilePointer + 3] - 0x30) * 10) + ((FileData[FilePointer + 4] - 0x30) * 1));
                    TC9 = (float)((TC9 * 1.8) + 32);  //C to F
                    if (FileData[FilePointer + 1] == '-') TC9 = -TC9;
                    FilePointer += 4;

                    TC10 = (float)(((FileData[FilePointer + 2] - 0x30) * 100) + ((FileData[FilePointer + 3] - 0x30) * 10) + ((FileData[FilePointer + 4] - 0x30) * 1));
                    TC10 = (float)((TC10 * 1.8) + 32);  //C to F
                    if (FileData[FilePointer + 1] == '-') TC10 = -TC10;
                    FilePointer += 4;

                    TC11 = (float)(((FileData[FilePointer + 2] - 0x30) * 100) + ((FileData[FilePointer + 3] - 0x30) * 10) + ((FileData[FilePointer + 4] - 0x30) * 1));
                    TC11 = (float)((TC11 * 1.8) + 32);  //C to F
                    if (FileData[FilePointer + 1] == '-') TC11 = -TC11;
                    FilePointer += 4;

                    TC12 = (float)(((FileData[FilePointer + 2] - 0x30) * 100) + ((FileData[FilePointer + 3] - 0x30) * 10) + ((FileData[FilePointer + 4] - 0x30) * 1));
                    TC12 = (float)((TC12 * 1.8) + 32);  //C to F
                    if (FileData[FilePointer + 1] == '-') TC12 = -TC12;
                    FilePointer += 4;
                    FilePointer += 4;//TC13
                    FilePointer += 4;//TC14

                    ElTrim = (float)(((FileData[FilePointer + 2] - 0x30) * 1000) + ((FileData[FilePointer + 3] - 0x30) * 100)
                        + ((FileData[FilePointer + 4] - 0x30) * 10) + ((FileData[FilePointer + 5] - 0x30) * 1));
                    ElTrim = ElTrim / 10;




                    AcroF = (float)(((FileData[FilePointer + 8] - 0x30) * 1000) + ((FileData[FilePointer + 9] - 0x30) * 100)
                        + ((FileData[FilePointer + 10] - 0x30) * 10) + ((FileData[FilePointer + 11] - 0x30) * 1));
                    AcroF = AcroF / 10;




                    TempString = Time.ToString("N0")
                    + ", " + T1.ToString("N1")
                    + ", " + T2.ToString("N1")
                    + ", " + T3.ToString("N1")
                    + ", " + T4.ToString("N1")
                    +", " + Pitch.ToString("N1")
                    + ", " + Roll.ToString("N1")
                    + ", " + Yaw.ToString("")
                    + ", " + IAS.ToString("N1")
                    + ", " + PAlt.ToString("")
                    + ", " + TurnRate.ToString("N1")
                    + ", " + LatG.ToString("N1")
                    + ", " + VertG.ToString("N1")
                    + ", " + AoA.ToString("")
                    + ", " + VSpeed.ToString("")
                    + ", " + OAT.ToString("")
                    + ", " + TAS.ToString("N1")
                    + ", " + Baro.ToString("")
                    + ", " + DA.ToString("")
                    + ", " + WS.ToString("")
                    + ", " + WD.ToString("")
                    + ", " + OP.ToString("")
                    + ", " + OT.ToString("")
                    + ", " + RPML.ToString("")
                    + ", " + RPMR.ToString("")
                    + ", " + MAP.ToString("N1")
                    + ", " + FuelFlow.ToString("N1")
                    + ", " + FP.ToString("")
                    + ", " + FuelRem.ToString("N1")
                    + ", " + V.ToString("N1")
                    + ", " + Amps.ToString("N1")
                    + ", " + Hobbs.ToString("")
                    + ", " + Tach.ToString("")
                    + ", " + TC1.ToString("")
                    + ", " + TC2.ToString("")
                    + ", " + TC3.ToString("")
                    + ", " + TC4.ToString("")
                    + ", " + TC5.ToString("")
                    + ", " + TC6.ToString("")
                    + ", " + TC7.ToString("")
                    + ", " + TC8.ToString("")
                    + ", " + TC9.ToString("")
                    + ", " + TC10.ToString("")
                    + ", " + TC11.ToString("")
                    + ", " + TC12.ToString("")
                    + ", " + ElTrim.ToString("N1")
                    + ", " + AcroF.ToString("N1");


                    tw.WriteLine(TempString);
//                    Time = (float)(Time + TimeInc);

                    while (FilePointer < FileLength)
                    {
                        if (FileData[FilePointer] == '!')
                            break;
                        FilePointer++;
                    }
                    if (FilePointer >= (FileLength - 300))
                        goto TidyExit;
                    //Add a test here to see if there is at least two more lines of data in the file else bail


                }


            TidyExit:
                tw.Close();
                TxtToLog.Text = "Txt to Log";

            } //try 
            catch (Exception ex)
            {
                throw;
            }








        }

        private void TxtToLog48_Click(object sender, EventArgs e)
        {
            Byte mychar;
            UInt32 i, FilePointer, FileLength = 0;
            String OpenFileName, TempString;
            //  Byte[] LineData = new Byte[0x20];
            //  UInt16[] PiDList = new UInt16[30];
            float Time = 0;
            float Pitch, Roll, Yaw, IAS, PAlt, TurnRate, LatG, VertG, AoA, VSpeed, OAT, TAS, Baro, DA, WS, WD, OP, OT, RPML, RPMR, MAP, FuelFlow, FP, FuelRem, V, Amps, Hobbs, Tach, TC1, TC2, TC3, TC4, TC5, TC6, TC7, TC8, TC9, TC10, TC11, TC12, ElTrim, AcroF;
            double TimeInc = (0.00009*2);
            try
            {


                TxtToLog48.Text = "working";

                
                
                OpenFileDialog ofn = new OpenFileDialog();
                ofn.Filter = "Log Files (*.txt)|*.txt|All Files (*.*)|*.*";
                ofn.Title = "Type File";
                if (ofn.ShowDialog() == DialogResult.Cancel) return;
                FileInfo FI = new FileInfo(@ofn.FileName);
                FileLength = (UInt32)(FI.Length);
                Byte[] FileData = new Byte[FileLength];
                OpenFileName = ofn.FileName;
                FileStream inStream = File.OpenRead(OpenFileName);
                BinaryReader br = new BinaryReader(inStream);
                for (i = 0; i < FileLength; i++)
                {
                    FileData[i] = br.ReadByte();
                }
                br.Close();
                inStream.Close();



                FilePointer = 1900;
                while (FilePointer <= FileLength)
                {
                    if (FileData[FilePointer] == '!') break;
                    FilePointer++;
                }
                // test charictors to make sure there are at least one AHARS and one EMS data line

                if ((FileData[FilePointer + 1] != '1') || (FileData[FilePointer + 75] != '3'))
                {
                    MessageBox.Show("Need at least one AHARS and EMS record.  Exiting...", "Input Error",
                    MessageBoxButtons.OKCancel, MessageBoxIcon.Asterisk);
                    return;
                }

                TxtToLog48.Text = "working";

                BaudRate.Text = "4800";


                TempString = "Time,Pitch,Roll,Yaw,IAS,PAlt,TurnRate,LatG,VertG,AoA,VSpeed,OAT,TAS,Baro,DA,WS,WD,OP,OT,RPML,RPMR,MAP,FuelFlow,FP,FuelRem,V,Amps,Hobbs,Tach,CHT6,EGT6,CHT5,EGT5,CHT4,EGT4,CHT2,EGT2,CHT3,EGT3,CHT1,EGT1,ElTrim,AcroF";

                //Time Incriment determined from log at 2400 baud as follows
                // 12:20:25 - 11:41:19 = 39:06 or 39.1 minutes for 1708 records or .02289 minutes/record (which is one sample every 1.37 seconds)
                // each record will be incrimented by .02289 minutes with time displayed in minutes

                //

                OpenFileName = OpenFileName + ".LOG";
                TextWriter tw = new StreamWriter(OpenFileName);

                tw.WriteLine(TempString);

                // set scales
                //low values
                Pitch = 0; Roll = 0; Yaw = 0; IAS = 0; PAlt = 0; TurnRate = 0; LatG = 0; VertG = 0; AoA = 0; VSpeed = 0; OAT = 0; TAS = 0; Baro = 0; DA = 0; WS = 0;
                WD = 0; OP = 0; OT = 0; RPML = 0; RPMR = 0; MAP = 0; FuelFlow = 0; FP = 0; FuelRem = 0; V = 0; Amps = 0; Hobbs = 0; Tach = 0;
                TC1 = 0; TC2 = 0; TC3 = 0; TC4 = 0; TC5 = 0; TC6 = 0; TC7 = 0; TC8 = 0; TC9 = 0; TC10 = 0; TC11 = 0; TC12 = 0; ElTrim = 0; AcroF = 0;
                TempString = Time.ToString("N2")
                + ", " + Pitch.ToString("N1")
                + ", " + Roll.ToString("N1")
                + ", " + Yaw.ToString("")
                + ", " + IAS.ToString("N1")
                + ", " + PAlt.ToString("")
                + ", " + TurnRate.ToString("N1")
                + ", " + LatG.ToString("N1")
                + ", " + VertG.ToString("N1")
                + ", " + AoA.ToString("")
                + ", " + VSpeed.ToString("")
                + ", " + OAT.ToString("")
                + ", " + TAS.ToString("N1")
                + ", " + Baro.ToString("")
                + ", " + DA.ToString("")
                + ", " + WS.ToString("")
                + ", " + WD.ToString("")
                + ", " + OP.ToString("")
                + ", " + OT.ToString("")
                + ", " + RPML.ToString("")
                + ", " + RPMR.ToString("")
                + ", " + MAP.ToString("N1")
                + ", " + FuelFlow.ToString("N1")
                + ", " + FP.ToString("")
                + ", " + FuelRem.ToString("N1")
                + ", " + V.ToString("N1")
                + ", " + Amps.ToString("N1")
                + ", " + Hobbs.ToString("")
                + ", " + Tach.ToString("")
                + ", " + TC1.ToString("")
                + ", " + TC2.ToString("")
                + ", " + TC3.ToString("")
                + ", " + TC4.ToString("")
                + ", " + TC5.ToString("")
                + ", " + TC6.ToString("")
                + ", " + TC7.ToString("")
                + ", " + TC8.ToString("")
                + ", " + TC9.ToString("")
                + ", " + TC10.ToString("")
                + ", " + TC11.ToString("")
                + ", " + TC12.ToString("")
                + ", " + ElTrim.ToString("N1")
                + ", " + AcroF.ToString("N1");

                tw.WriteLine(TempString);
                Time = (float)(Time + TimeInc);

                // high values
                Pitch = 0; Roll = 0; Yaw = 0; IAS = 0; PAlt = 0; TurnRate = 0; LatG = 0; VertG = 0; AoA = 0; VSpeed = 0; OAT = 0; TAS = 0; Baro = 0; DA = 0; WS = 0;
                WD = 0; OP = 110; OT = 220; RPML = 2900; RPMR = 2900; MAP = 32; FuelFlow = 30; FP = 0; FuelRem = 0; V = 0; Amps = 0; Hobbs = 0; Tach = 0;
                TC1 = 450; TC2 = 1500; TC3 = 450; TC4 = 1500; TC5 = 450; TC6 = 1500; TC7 = 450; TC8 = 1500; TC9 = 450; TC10 = 1500; TC11 = 450; TC12 = 1500; ElTrim = 0; AcroF = 0;
                TempString = Time.ToString("N2")
                + ", " + Pitch.ToString("N1")
                + ", " + Roll.ToString("N1")
                + ", " + Yaw.ToString("")
                + ", " + IAS.ToString("N1")
                + ", " + PAlt.ToString("")
                + ", " + TurnRate.ToString("N1")
                + ", " + LatG.ToString("N1")
                + ", " + VertG.ToString("N1")
                + ", " + AoA.ToString("")
                + ", " + VSpeed.ToString("")
                + ", " + OAT.ToString("")
                + ", " + TAS.ToString("N1")
                + ", " + Baro.ToString("")
                + ", " + DA.ToString("")
                + ", " + WS.ToString("")
                + ", " + WD.ToString("")
                + ", " + OP.ToString("")
                + ", " + OT.ToString("")
                + ", " + RPML.ToString("")
                + ", " + RPMR.ToString("")
                + ", " + MAP.ToString("N1")
                + ", " + FuelFlow.ToString("N1")
                + ", " + FP.ToString("")
                + ", " + FuelRem.ToString("N1")
                + ", " + V.ToString("N1")
                + ", " + Amps.ToString("N1")
                + ", " + Hobbs.ToString("")
                + ", " + Tach.ToString("")
                + ", " + TC1.ToString("")
                + ", " + TC2.ToString("")
                + ", " + TC3.ToString("")
                + ", " + TC4.ToString("")
                + ", " + TC5.ToString("")
                + ", " + TC6.ToString("")
                + ", " + TC7.ToString("")
                + ", " + TC8.ToString("")
                + ", " + TC9.ToString("")
                + ", " + TC10.ToString("")
                + ", " + TC11.ToString("")
                + ", " + TC12.ToString("")
                + ", " + ElTrim.ToString("N1")
                + ", " + AcroF.ToString("N1");

                tw.WriteLine(TempString);
                Time = (float)(Time + TimeInc);









                while (FilePointer <= FileLength)
                {




                    Pitch = (float)(((FileData[FilePointer + 12] - 0x30) * 100) + ((FileData[FilePointer + 13] - 0x30) * 10) + ((FileData[FilePointer + 14] - 0x30) * 1));
                    Pitch = Pitch / 10;
                    if (FileData[FilePointer + 11] == '-') Pitch = -Pitch;
                    Roll = (float)(((FileData[FilePointer + 16] - 0x30) * 1000) + ((FileData[FilePointer + 17] - 0x30) * 100) + ((FileData[FilePointer + 18] - 0x30) * 10) + ((FileData[FilePointer + 19] - 0x30) * 1));
                    Roll = Roll / 10;
                    if (FileData[FilePointer + 15] == '-') Roll = -Roll;
                    Yaw = (float)(((FileData[FilePointer + 20] - 0x30) * 100) + ((FileData[FilePointer + 21] - 0x30) * 10) + ((FileData[FilePointer + 22] - 0x30) * 1));
                    //Yaw = Yaw / 10;
                    IAS = (float)(((FileData[FilePointer + 23] - 0x30) * 1000) + ((FileData[FilePointer + 24] - 0x30) * 100)
                        + ((FileData[FilePointer + 25] - 0x30) * 10) + ((FileData[FilePointer + 26] - 0x30) * 1));
                    IAS = IAS / 10;
                    PAlt = (float)(((FileData[FilePointer + 28] - 0x30) * 10000) + ((FileData[FilePointer + 29] - 0x30) * 1000)
                        + ((FileData[FilePointer + 30] - 0x30) * 100) + ((FileData[FilePointer + 31] - 0x30) * 10) + ((FileData[FilePointer + 32] - 0x30) * 1));
                    if (FileData[FilePointer + 27] == '-') PAlt = -PAlt;
                    TurnRate = (float)(((FileData[FilePointer + 34] - 0x30) * 100) + ((FileData[FilePointer + 35] - 0x30) * 10) + ((FileData[FilePointer + 36] - 0x30) * 1));
                    TurnRate = TurnRate / 10;
                    if (FileData[FilePointer + 33] == '-') TurnRate = -TurnRate;
                    LatG = (float)(((FileData[FilePointer + 38] - 0x30) * 10) + (FileData[FilePointer + 39] - 0x30));
                    LatG = LatG / 10;
                    if (FileData[FilePointer + 37] == '-') LatG = -LatG;
                    VertG = (float)(((FileData[FilePointer + 41] - 0x30) * 10) + (FileData[FilePointer + 42] - 0x30));
                    VertG = VertG / 10;
                    if (FileData[FilePointer + 40] == '-') VertG = -VertG;
                    AoA = (float)(((FileData[FilePointer + 43] - 0x30) * 10) + (FileData[FilePointer + 44] - 0x30));
                    VSpeed = (float)(((FileData[FilePointer + 46] - 0x30) * 100) + ((FileData[FilePointer + 47] - 0x30) * 10) + ((FileData[FilePointer + 48] - 0x30) * 1));
                    VSpeed *= 10;
                    if (FileData[FilePointer + 45] == '-') VSpeed = -VSpeed;
                    OAT = (float)(((FileData[FilePointer + 50] - 0x30) * 10) + (FileData[FilePointer + 51] - 0x30));
                    OAT = (float)((OAT * 1.8) + 32);  //C to F
                    if (FileData[FilePointer + 49] == '-') OAT = -OAT;
                    TAS = (float)(((FileData[FilePointer + 52] - 0x30) * 1000) + ((FileData[FilePointer + 53] - 0x30) * 100)
                        + ((FileData[FilePointer + 54] - 0x30) * 10) + ((FileData[FilePointer + 55] - 0x30) * 1));
                    TAS = TAS / 10;
                    Baro = (float)(((FileData[FilePointer + 56] - 0x30) * 100) + ((FileData[FilePointer + 57] - 0x30) * 10) + ((FileData[FilePointer + 58] - 0x30) * 1));
                    Baro = Baro / 10;
                    DA = (float)(((FileData[FilePointer + 60] - 0x30) * 10000) + ((FileData[FilePointer + 61] - 0x30) * 1000)
                        + ((FileData[FilePointer + 62] - 0x30) * 100) + ((FileData[FilePointer + 63] - 0x30) * 10) + ((FileData[FilePointer + 64] - 0x30) * 1));
                    if (FileData[FilePointer + 59] == '-') DA = -DA;



                    if (FileData[FilePointer + 65] == 'X') { WD = 0; }
                    else
                    {
                        WD = (float)(((FileData[FilePointer + 65] - 0x30) * 100) + ((FileData[FilePointer + 66] - 0x30) * 10) + ((FileData[FilePointer + 67] - 0x30) * 1));
                    }


                    if (FileData[FilePointer + 68] == 'X') { WS = 0; }
                    else
                    {
                        WS = (float)(((FileData[FilePointer + 68] - 0x30) * 10) + (FileData[FilePointer + 69] - 0x30));
                    }



                    FilePointer += 74; //point at start of next line
                    OP = (float)(((FileData[FilePointer + 11] - 0x30) * 100) + ((FileData[FilePointer + 12] - 0x30) * 10) + ((FileData[FilePointer + 13] - 0x30) * 1));
                    OT = (float)(((FileData[FilePointer + 15] - 0x30) * 100) + ((FileData[FilePointer + 16] - 0x30) * 10) + ((FileData[FilePointer + 17] - 0x30) * 1));
                    OT = (float)((OT * 1.8) + 32);  //C to F
                    if (FileData[FilePointer + 14] == '-') OT = -OT;
                    RPML = (float)(((FileData[FilePointer + 18] - 0x30) * 1000) + ((FileData[FilePointer + 19] - 0x30) * 100)
                        + ((FileData[FilePointer + 20] - 0x30) * 10) + ((FileData[FilePointer + 21] - 0x30) * 1));
                    RPMR = (float)(((FileData[FilePointer + 22] - 0x30) * 1000) + ((FileData[FilePointer + 23] - 0x30) * 100)
                        + ((FileData[FilePointer + 24] - 0x30) * 10) + ((FileData[FilePointer + 25] - 0x30) * 1));
                    MAP = (float)(((FileData[FilePointer + 26] - 0x30) * 100) + ((FileData[FilePointer + 27] - 0x30) * 10) + ((FileData[FilePointer + 28] - 0x30) * 1));
                    MAP = MAP / 10;
                    if (MAP > 34) MAP = 34;
                    FuelFlow = (float)(((FileData[FilePointer + 29] - 0x30) * 100) + ((FileData[FilePointer + 30] - 0x30) * 10) + ((FileData[FilePointer + 31] - 0x30) * 1));
                    FuelFlow = FuelFlow / 10;
                    //skip 3 for second fuel flow not used
                    FP = (float)(((FileData[FilePointer + 35] - 0x30) * 100) + ((FileData[FilePointer + 36] - 0x30) * 10) + ((FileData[FilePointer + 37] - 0x30) * 1));
                    FP = FP / 10;
                    //skip 6 for quantity L & R not used

                    FuelRem = (float)(((FileData[FilePointer + 44] - 0x30) * 100) + ((FileData[FilePointer + 45] - 0x30) * 10) + ((FileData[FilePointer + 46] - 0x30) * 1));
                    FuelRem = FuelRem / 10;
                    V = (float)(((FileData[FilePointer + 47] - 0x30) * 100) + ((FileData[FilePointer + 48] - 0x30) * 10) + ((FileData[FilePointer + 49] - 0x30) * 1));
                    V = V / 10; //skip 3 V2 not used
                    Amps = (float)(((FileData[FilePointer + 54] - 0x30) * 100) + ((FileData[FilePointer + 55] - 0x30) * 10) + ((FileData[FilePointer + 56] - 0x30) * 1));
                    Amps = Amps / 10;
                    if (FileData[FilePointer + 53] == '-') Amps = -Amps;
                    Hobbs = (float)(((FileData[FilePointer + 57] - 0x30) * 10000) + ((FileData[FilePointer + 58] - 0x30) * 1000)
                        + ((FileData[FilePointer + 59] - 0x30) * 100) + ((FileData[FilePointer + 60] - 0x30) * 10) + ((FileData[FilePointer + 61] - 0x30) * 1));
                    Hobbs = Hobbs / 10;
                    Tach = (float)(((FileData[FilePointer + 62] - 0x30) * 10000) + ((FileData[FilePointer + 63] - 0x30) * 1000)
                        + ((FileData[FilePointer + 64] - 0x30) * 100) + ((FileData[FilePointer + 65] - 0x30) * 10) + ((FileData[FilePointer + 66] - 0x30) * 1));
                    Tach = Tach / 10;
                    //TCs will use incrimented file pointer as they simply repeat in form
                    FilePointer = FilePointer + 66;
                    TC1 = (float)(((FileData[FilePointer + 2] - 0x30) * 100) + ((FileData[FilePointer + 3] - 0x30) * 10) + ((FileData[FilePointer + 4] - 0x30) * 1));
                    TC1 = (float)((TC1 * 1.8) + 32);  //C to F
                    if (FileData[FilePointer + 1] == '-') TC1 = -TC1;
                    FilePointer += 4;

                    TC2 = (float)(((FileData[FilePointer + 2] - 0x30) * 100) + ((FileData[FilePointer + 3] - 0x30) * 10) + ((FileData[FilePointer + 4] - 0x30) * 1));
                    TC2 = (float)((TC2 * 1.8) + 32);  //C to F
                    if (FileData[FilePointer + 1] == '-') TC2 = -TC2;
                    FilePointer += 4;

                    TC3 = (float)(((FileData[FilePointer + 2] - 0x30) * 100) + ((FileData[FilePointer + 3] - 0x30) * 10) + ((FileData[FilePointer + 4] - 0x30) * 1));
                    TC3 = (float)((TC3 * 1.8) + 32);  //C to F
                    if (FileData[FilePointer + 1] == '-') TC3 = -TC3;
                    FilePointer += 4;

                    TC4 = (float)(((FileData[FilePointer + 2] - 0x30) * 100) + ((FileData[FilePointer + 3] - 0x30) * 10) + ((FileData[FilePointer + 4] - 0x30) * 1));
                    TC4 = (float)((TC4 * 1.8) + 32);  //C to F
                    if (FileData[FilePointer + 1] == '-') TC4 = -TC4;
                    FilePointer += 4;

                    TC5 = (float)(((FileData[FilePointer + 2] - 0x30) * 100) + ((FileData[FilePointer + 3] - 0x30) * 10) + ((FileData[FilePointer + 4] - 0x30) * 1));
                    TC5 = (float)((TC5 * 1.8) + 32);  //C to F
                    if (FileData[FilePointer + 1] == '-') TC5 = -TC5;
                    FilePointer += 4;

                    TC6 = (float)(((FileData[FilePointer + 2] - 0x30) * 100) + ((FileData[FilePointer + 3] - 0x30) * 10) + ((FileData[FilePointer + 4] - 0x30) * 1));
                    TC6 = (float)((TC6 * 1.8) + 32);  //C to F
                    if (FileData[FilePointer + 1] == '-') TC6 = -TC6;
                    FilePointer += 4;

                    TC7 = (float)(((FileData[FilePointer + 2] - 0x30) * 100) + ((FileData[FilePointer + 3] - 0x30) * 10) + ((FileData[FilePointer + 4] - 0x30) * 1));
                    TC7 = (float)((TC7 * 1.8) + 32);  //C to F
                    if (FileData[FilePointer + 1] == '-') TC7 = -TC7;
                    FilePointer += 4;

                    TC8 = (float)(((FileData[FilePointer + 2] - 0x30) * 100) + ((FileData[FilePointer + 3] - 0x30) * 10) + ((FileData[FilePointer + 4] - 0x30) * 1));
                    TC8 = (float)((TC8 * 1.8) + 32);  //C to F
                    if (FileData[FilePointer + 1] == '-') TC8 = -TC8;
                    FilePointer += 4;

                    TC9 = (float)(((FileData[FilePointer + 2] - 0x30) * 100) + ((FileData[FilePointer + 3] - 0x30) * 10) + ((FileData[FilePointer + 4] - 0x30) * 1));
                    TC9 = (float)((TC9 * 1.8) + 32);  //C to F
                    if (FileData[FilePointer + 1] == '-') TC9 = -TC9;
                    FilePointer += 4;

                    TC10 = (float)(((FileData[FilePointer + 2] - 0x30) * 100) + ((FileData[FilePointer + 3] - 0x30) * 10) + ((FileData[FilePointer + 4] - 0x30) * 1));
                    TC10 = (float)((TC10 * 1.8) + 32);  //C to F
                    if (FileData[FilePointer + 1] == '-') TC10 = -TC10;
                    FilePointer += 4;

                    TC11 = (float)(((FileData[FilePointer + 2] - 0x30) * 100) + ((FileData[FilePointer + 3] - 0x30) * 10) + ((FileData[FilePointer + 4] - 0x30) * 1));
                    TC11 = (float)((TC11 * 1.8) + 32);  //C to F
                    if (FileData[FilePointer + 1] == '-') TC11 = -TC11;
                    FilePointer += 4;

                    TC12 = (float)(((FileData[FilePointer + 2] - 0x30) * 100) + ((FileData[FilePointer + 3] - 0x30) * 10) + ((FileData[FilePointer + 4] - 0x30) * 1));
                    TC12 = (float)((TC12 * 1.8) + 32);  //C to F
                    if (FileData[FilePointer + 1] == '-') TC12 = -TC12;
                    FilePointer += 4;
                    FilePointer += 4;//TC13
                    FilePointer += 4;//TC14

                    ElTrim = (float)(((FileData[FilePointer + 2] - 0x30) * 1000) + ((FileData[FilePointer + 3] - 0x30) * 100)
                        + ((FileData[FilePointer + 4] - 0x30) * 10) + ((FileData[FilePointer + 5] - 0x30) * 1));
                    ElTrim = ElTrim / 10;




                    AcroF = (float)(((FileData[FilePointer + 8] - 0x30) * 1000) + ((FileData[FilePointer + 9] - 0x30) * 100)
                        + ((FileData[FilePointer + 10] - 0x30) * 10) + ((FileData[FilePointer + 11] - 0x30) * 1));
                    AcroF = AcroF / 10;




                    TempString = Time.ToString("N2")
                    + ", " + Pitch.ToString("N1")
                    + ", " + Roll.ToString("N1")
                    + ", " + Yaw.ToString("")
                    + ", " + IAS.ToString("N1")
                    + ", " + PAlt.ToString("")
                    + ", " + TurnRate.ToString("N1")
                    + ", " + LatG.ToString("N1")
                    + ", " + VertG.ToString("N1")
                    + ", " + AoA.ToString("")
                    + ", " + VSpeed.ToString("")
                    + ", " + OAT.ToString("")
                    + ", " + TAS.ToString("N1")
                    + ", " + Baro.ToString("")
                    + ", " + DA.ToString("")
                    + ", " + WS.ToString("")
                    + ", " + WD.ToString("")
                    + ", " + OP.ToString("")
                    + ", " + OT.ToString("")
                    + ", " + RPML.ToString("")
                    + ", " + RPMR.ToString("")
                    + ", " + MAP.ToString("N1")
                    + ", " + FuelFlow.ToString("N1")
                    + ", " + FP.ToString("")
                    + ", " + FuelRem.ToString("N1")
                    + ", " + V.ToString("N1")
                    + ", " + Amps.ToString("N1")
                    + ", " + Hobbs.ToString("")
                    + ", " + Tach.ToString("")
                    + ", " + TC1.ToString("")
                    + ", " + TC2.ToString("")
                    + ", " + TC3.ToString("")
                    + ", " + TC4.ToString("")
                    + ", " + TC5.ToString("")
                    + ", " + TC6.ToString("")
                    + ", " + TC7.ToString("")
                    + ", " + TC8.ToString("")
                    + ", " + TC9.ToString("")
                    + ", " + TC10.ToString("")
                    + ", " + TC11.ToString("")
                    + ", " + TC12.ToString("")
                    + ", " + ElTrim.ToString("N1")
                    + ", " + AcroF.ToString("N1");

                    tw.WriteLine(TempString);
                    Time = (float)(Time + TimeInc);

                    while (FilePointer < FileLength)
                    {
                        if (FileData[FilePointer] == '!')
                            break;
                        FilePointer++;
                    }
                    if (FilePointer >= (FileLength - 300))
                        goto TidyExit;
                    //Add a test here to see if there is at least two more lines of data in the file else bail


                }


            TidyExit:
                tw.Close();
                TxtToLog48.Text = "Txt to Log 4800";

            } //try 
            catch (Exception ex)
            {
                throw;
            }





        }//TxtToLog click

     
    }
}